%global     debug_package   %{nil}
%global     module_slug v4l2loopback-dc

%{!?_modulesloaddir:%global _modulesloaddir %{_prefix}/lib/modules-load.d}
%{!?_modprobedir:%global _modprobedir %{_prefix}/lib/modprobe.d}

Name:           droidcam-kmod
Version:        2.1.2
Release:        1%{?dist}
Summary:        DroidCam's %{module_slug} kernel module

License:        GPLv2
URL:            https://dev47apps.com/droidcam/linux/
Source0:        https://github.com/dev47apps/droidcam/archive/v%{version}.tar.gz
Source1:        modules-load.conf
Source2:        modprobe.conf

Provides:       %{module_slug}-kmod-common = %{?epoch:%{epoch}:}%{version}-%{release}

Requires:       kmod-%{module_slug} >= %{?epoch:%{epoch}:}%{version} or akmod-%{module_slug} >= %{?epoch:%{epoch}:}%{version}

BuildRequires:  kmodtool
BuildRequires:  kernel-devel

%{!?kernels:BuildRequires:  buildsys-build-rpmfusion-kerneldevpkgs-current}


%description
Kernel module for DroidCam's %{module_slug} drivers.


%{expand:%(kmodtool --target %{_target_cpu} %{!?kernels:--repo rpmfusion}%{?kernels:--for-kernels "%{kernels}"} --kmodname %{module_slug} 2>/dev/null)}


%prep
%{?kmodtool_check}
%autosetup -n droidcam-%{version}
for kernel_version in %{?kernel_versions}; do
    version="${kernel_version%%___*}"
    cp -a v4l2loopback "_kmod_build_${version}"
done


%build
for kernel_version in %{?kernel_versions}; do
    version="${kernel_version%%___*}"
    path="${kernel_version#*___}"
    make %{?_smp_mflags} -C "${path}" M="${PWD}/_kmod_build_${version}"
done


%install
for kernel_version in %{?kernel_versions}; do
    version="${kernel_version%%___*}"
    install -p -D -m 0755 "_kmod_build_${version}/%{module_slug}.ko" \
        "%{buildroot}%{kmodinstdir_prefix}${version}%{kmodinstdir_postfix}%{module_slug}.ko"
done
%{?akmod_install}

install -p -D -m 0644 %{SOURCE1} %{buildroot}%{_modulesloaddir}/%{module_slug}.conf
install -p -D -m 0644 %{SOURCE2} %{buildroot}%{_modprobedir}/%{module_slug}.conf


%files
%license LICENSE
%{_modulesloaddir}/%{module_slug}.conf
%{_modprobedir}/%{module_slug}.conf


%changelog
* Sat Feb 10 2024 Jarryd Lisher <jarryd@jlisher.com> - 2.1.2-1
- Update dependencies
- Clean up kernal module

* Thu Feb 08 2024 Jarryd Lisher <jarryd@jlisher.com> - 2.1.2-0
- Initial Release
